<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/writelog.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>writelog.c</h1><a href="writelog_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: writelog.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#endif</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#include &quot;spintorq/spintorq.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg/llg.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="keyword">static</span> <span class="keywordtype">int</span>     doinit=1;
<a name="l00044"></a>00044 <span class="keyword">static</span> FILE    *logfile; 
<a name="l00046"></a>00046 <span class="keyword">static</span> Vec     V1Mtot[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]; 
<a name="l00048"></a><a class="code" href="writelog_8c.html#acf315ef77c9cda0a419e75748c5ad9a8">00048</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#acf315ef77c9cda0a419e75748c5ad9a8">Vec3VolAvg</a>(Vec v,PetscReal* res)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="comment">/* calculate Mtot (ignoring Js) */</span>
<a name="l00053"></a>00053   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00054"></a>00054     ierr = VecDot(v,V1Mtot[i],&amp;res[i]);CHKERRQ(ierr);
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="writelog_8c.html#aa4b9c3d7fa8f610a0ae44ca0551f03ad">00061</a> <span class="keywordtype">int</span> <a class="code" href="writelog_8c.html#aa4b9c3d7fa8f610a0ae44ca0551f03ad">WriteLogInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="keywordtype">int</span> rank,size;
<a name="l00066"></a>00066   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00067"></a>00067   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   PetscReal *vvol;
<a name="l00070"></a>00070   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,&amp;vvol);CHKERRQ(ierr);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">/* calculate magnetic volume */</span>
<a name="l00073"></a>00073   PetscReal Vtot;
<a name="l00074"></a>00074   Vtot=0.0;
<a name="l00075"></a>00075   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;j++) {
<a name="l00076"></a>00076     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+4]&gt;0.0) {
<a name="l00077"></a>00077       Vtot += vvol[j];
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080   PetscReal temp;
<a name="l00081"></a>00081   ierr = PetscGlobalSum(&amp;Vtot,&amp;temp,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00082"></a>00082   Vtot=temp;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   PetscInfo2(0,<span class="stringliteral">&quot;Using total volume %g (%g)\n&quot;</span>,Vtot,gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>);
<a name="l00085"></a>00085   <span class="comment">/* Vtot, gdata-&gt;totvol might be different because the latter is sum over gdata-&gt;elevol */</span>
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="comment">/* calculate average M only over magnetic regions */</span>
<a name="l00088"></a>00088   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00089"></a>00089     ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;V1Mtot[i]);CHKERRQ(ierr);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091     PetscReal *v1m;
<a name="l00092"></a>00092     ierr = VecGetArray(V1Mtot[i],&amp;v1m);CHKERRQ(ierr);
<a name="l00093"></a>00093     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;j++) {
<a name="l00094"></a>00094       <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+4]&gt;0.0) {
<a name="l00095"></a>00095         v1m[ND*j+i]=vvol[j];
<a name="l00096"></a>00096       }
<a name="l00097"></a>00097     }
<a name="l00098"></a>00098     ierr = VecRestoreArray(V1Mtot[i],&amp;v1m);CHKERRQ(ierr);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     ierr = VecScale(V1Mtot[i],1.0/Vtot);CHKERRQ(ierr);
<a name="l00101"></a>00101   }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a21683f539bbd0d68c0870cd0ece0de58">vertvol</a>,&amp;vvol);CHKERRQ(ierr);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (rank) {
<a name="l00106"></a>00106     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00107"></a>00107   }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keywordtype">char</span> fmesh[256];
<a name="l00110"></a>00110   ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,<span class="stringliteral">&quot;.log&quot;</span>);CHKERRQ(ierr);
<a name="l00111"></a>00111   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;a&quot;</span>,&amp;logfile);CHKERRQ(ierr);
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (!logfile) {
<a name="l00113"></a>00113     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00114"></a>00114   }
<a name="l00115"></a>00115   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   PetscGetDate(fmesh,255);
<a name="l00118"></a>00118   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,<span class="stringliteral">&quot;#.date: %s\n&quot;</span>,fmesh);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">/*     1   2    3    4    5    6    7    8    9   10   11   12   13   14   15   16   17   18   20 */</span>
<a name="l00121"></a>00121   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00122"></a>00122     <span class="stringliteral">&quot;#.%3s %4s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s\n&quot;</span>,
<a name="l00123"></a>00123     <span class="stringliteral">&quot;.1:&quot;</span>,
<a name="l00124"></a>00124     <span class="stringliteral">&quot; 2:&quot;</span>,
<a name="l00125"></a>00125     <span class="stringliteral">&quot; 3:&quot;</span>,
<a name="l00126"></a>00126     <span class="stringliteral">&quot; 4:&quot;</span>,
<a name="l00127"></a>00127     <span class="stringliteral">&quot; 5:&quot;</span>,
<a name="l00128"></a>00128     <span class="stringliteral">&quot; 6:&quot;</span>,
<a name="l00129"></a>00129     <span class="stringliteral">&quot; 7:&quot;</span>,
<a name="l00130"></a>00130     <span class="stringliteral">&quot; 8:&quot;</span>,
<a name="l00131"></a>00131     <span class="stringliteral">&quot; 9:&quot;</span>,
<a name="l00132"></a>00132     <span class="stringliteral">&quot;10:&quot;</span>,
<a name="l00133"></a>00133     <span class="stringliteral">&quot;11:&quot;</span>,
<a name="l00134"></a>00134     <span class="stringliteral">&quot;12:&quot;</span>,
<a name="l00135"></a>00135     <span class="stringliteral">&quot;13:&quot;</span>,
<a name="l00136"></a>00136     <span class="stringliteral">&quot;14:&quot;</span>,
<a name="l00137"></a>00137     <span class="stringliteral">&quot;15:&quot;</span>,
<a name="l00138"></a>00138     <span class="stringliteral">&quot;16:&quot;</span>,
<a name="l00139"></a>00139     <span class="stringliteral">&quot;17:&quot;</span>,
<a name="l00140"></a>00140     <span class="stringliteral">&quot;18:&quot;</span>,
<a name="l00141"></a>00141     <span class="stringliteral">&quot;20:&quot;</span>
<a name="l00142"></a>00142   );CHKERRQ(ierr);
<a name="l00143"></a>00143   <span class="comment">/*     1   2    3    4    5    6    7    8    9   10   11   12   13   14   15   16   17   18   20*/</span>
<a name="l00144"></a>00144   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00145"></a>00145     <span class="stringliteral">&quot;#.%3s %4s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s\n&quot;</span>,
<a name="l00146"></a>00146     <span class="stringliteral">&quot;.eq&quot;</span>,
<a name="l00147"></a>00147     <span class="stringliteral">&quot;inp&quot;</span>,
<a name="l00148"></a>00148     <span class="stringliteral">&quot;time&quot;</span>,
<a name="l00149"></a>00149     <span class="stringliteral">&quot;Hext&quot;</span>,
<a name="l00150"></a>00150     <span class="stringliteral">&quot;Etot&quot;</span>,
<a name="l00151"></a>00151     <span class="stringliteral">&quot;J//Hext&quot;</span>,
<a name="l00152"></a>00152     <span class="stringliteral">&quot;Mx&quot;</span>,
<a name="l00153"></a>00153     <span class="stringliteral">&quot;My&quot;</span>,
<a name="l00154"></a>00154     <span class="stringliteral">&quot;Mz&quot;</span>,
<a name="l00155"></a>00155     <span class="stringliteral">&quot;|M|&quot;</span>,
<a name="l00156"></a>00156     <span class="stringliteral">&quot;Edem&quot;</span>,
<a name="l00157"></a>00157 #ifdef EXCH
<a name="l00158"></a>00158     <span class="stringliteral">&quot;Eanionly&quot;</span>,
<a name="l00159"></a>00159 #<span class="keywordflow">else</span>
<a name="l00160"></a>00160     <span class="stringliteral">&quot;Eexchani&quot;</span>,
<a name="l00161"></a>00161 #endif
<a name="l00162"></a>00162     <span class="stringliteral">&quot;Eext&quot;</span>,
<a name="l00163"></a>00163 #ifdef EXCH
<a name="l00164"></a>00164     <span class="stringliteral">&quot;Eexchonly&quot;</span>,
<a name="l00165"></a>00165 #<span class="keywordflow">else</span>
<a name="l00166"></a>00166     <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00167"></a>00167 #endif
<a name="l00168"></a>00168     <span class="stringliteral">&quot;devNorm&quot;</span>,
<a name="l00169"></a>00169     <span class="stringliteral">&quot;mx|dM/dt|&quot;</span>,
<a name="l00170"></a>00170     <span class="stringliteral">&quot;timestep&quot;</span>,
<a name="l00171"></a>00171     <span class="stringliteral">&quot;tCPU&quot;</span>,
<a name="l00172"></a>00172     <span class="stringliteral">&quot;CPUtstep&quot;</span>
<a name="l00173"></a>00173   );CHKERRQ(ierr);
<a name="l00174"></a>00174   <span class="comment">/*     1   2    3    4    5    6    7    8    9   10   11   12   13   14   15   16   17   18   20*/</span>
<a name="l00175"></a>00175   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00176"></a>00176     <span class="stringliteral">&quot;#.%3s %4s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s %14s\n&quot;</span>,
<a name="l00177"></a>00177     <span class="comment">/* &quot;eq&quot;,           */</span> <span class="stringliteral">&quot;..-&quot;</span>,
<a name="l00178"></a>00178     <span class="comment">/* &quot;inp&quot;,          */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00179"></a>00179     <span class="comment">/* &quot; 3:time&quot;,      */</span> <span class="stringliteral">&quot;(ns)&quot;</span>,
<a name="l00180"></a>00180     <span class="comment">/* &quot; 4:Hext&quot;,      */</span> <span class="stringliteral">&quot;(kA/m)&quot;</span>,
<a name="l00181"></a>00181     <span class="comment">/* &quot; 5:Etot&quot;,      */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00182"></a>00182     <span class="comment">/* &quot; 6:J//Hext&quot;,   */</span> <span class="stringliteral">&quot;[J/Javg]&quot;</span>,
<a name="l00183"></a>00183     <span class="comment">/* &quot; 7:Mx&quot;,        */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00184"></a>00184     <span class="comment">/* &quot; 8:My&quot;,        */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00185"></a>00185     <span class="comment">/* &quot; 9:Mz&quot;,        */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00186"></a>00186     <span class="comment">/* &quot;10:|M|&quot;,       */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00187"></a>00187     <span class="comment">/* &quot;11:Edem&quot;,      */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00188"></a>00188     <span class="comment">/* &quot;12:Eexchani&quot;,  */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00189"></a>00189     <span class="comment">/* &quot;13:Eext&quot;,      */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00190"></a>00190 #ifdef EXCH
<a name="l00191"></a>00191     <span class="comment">/* &quot;14:Eexchonly&quot;, */</span> <span class="stringliteral">&quot;(J/m^3)&quot;</span>,
<a name="l00192"></a>00192 #<span class="keywordflow">else</span>
<a name="l00193"></a>00193     <span class="comment">/* &quot;14:void&quot;,      */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00194"></a>00194 #endif
<a name="l00195"></a>00195     <span class="comment">/* &quot;15:devNorm&quot;,   */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00196"></a>00196     <span class="comment">/* &quot;16:mx|dM/dt|&quot;, */</span> <span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00197"></a>00197     <span class="comment">/* &quot;17:timestep&quot;,  */</span> <span class="stringliteral">&quot;(ns)&quot;</span>,
<a name="l00198"></a>00198     <span class="comment">/* &quot;18:tCPU&quot;,      */</span> <span class="stringliteral">&quot;(s)&quot;</span>,
<a name="l00199"></a>00199     <span class="comment">/* &quot;20:CPUtstep&quot;,  */</span> <span class="stringliteral">&quot;(s)&quot;</span>
<a name="l00200"></a>00200   );CHKERRQ(ierr);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a><a class="code" href="writelog_8c.html#a54c21359e5dbade333f4c1ac856a3ffb">00206</a> <span class="keywordtype">int</span> <a class="code" href="writelog_8c.html#a54c21359e5dbade333f4c1ac856a3ffb">WriteLogData</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   <span class="keyword">static</span> PetscLogDouble tCPUstart=-1; 
<a name="l00209"></a>00209   <span class="keyword">static</span> PetscLogDouble tCPUlast;
<a name="l00210"></a>00210   <span class="keyword">static</span> PetscReal      timelast;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="keywordtype">int</span> rank,size;
<a name="l00215"></a>00215   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00216"></a>00216   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <span class="keywordflow">if</span> (doinit) {
<a name="l00219"></a>00219     tCPUstart=t_t1;
<a name="l00220"></a>00220     tCPUlast=t_t1;
<a name="l00221"></a>00221     timelast=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00222"></a>00222     ierr = <a class="code" href="writelog_8c.html#aa4b9c3d7fa8f610a0ae44ca0551f03ad">WriteLogInit</a>(gdata);CHKERRQ(ierr);
<a name="l00223"></a>00223     doinit=0;
<a name="l00224"></a>00224   }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   PetscReal devNorm;
<a name="l00227"></a>00227   devNorm=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,PETSC_MAX,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">/* calculate Mtot (ignoring Js) */</span>
<a name="l00230"></a>00230   PetscReal Mtot[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00231"></a>00231   ierr = <a class="code" href="magpario_8h.html#acf315ef77c9cda0a419e75748c5ad9a8">Vec3VolAvg</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,Mtot);CHKERRQ(ierr);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="comment">/* calculate average magnetization parallel to the external field */</span>
<a name="l00234"></a>00234   PetscReal valMpHext;
<a name="l00235"></a>00235   ierr = <a class="code" href="field_8h.html#aacac4af746c003dbd608d662ca2272e2">MpHext</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;valMpHext);CHKERRQ(ierr);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   PetscReal hext;
<a name="l00238"></a>00238   hext = <a class="code" href="field_8h.html#a48d0086e7ff33076be493f9379c45069">Hexternal_hext</a>();
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="comment">/* Edem&lt;0 occurs often in airboxes (should be zero)</span>
<a name="l00241"></a>00241 <span class="comment">   and due to magnetostatic field of other parts (not self-demag),</span>
<a name="l00242"></a>00242 <span class="comment">   which acts like an external field.</span>
<a name="l00243"></a>00243 <span class="comment">   As a result, lots of output when Hdemag_Energy function is called for each</span>
<a name="l00244"></a>00244 <span class="comment">   volume individually (with -logpid 1).</span>
<a name="l00245"></a>00245 <span class="comment">   Thus, better done in WriteLogData, where we check Edem for the whole model.</span>
<a name="l00246"></a>00246 <span class="comment">*/</span>
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>&lt;0) {
<a name="l00249"></a>00249     PetscPrintf(MPI_COMM_WORLD,
<a name="l00250"></a>00250       <span class="stringliteral">&quot;Warning: Edem&lt;0 at t=%g ns: Edem=%g J/m^3\n&quot;</span>,
<a name="l00251"></a>00251       gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9,
<a name="l00252"></a>00252       gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>
<a name="l00253"></a>00253     );
<a name="l00254"></a>00254   }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="comment">/*       1   2    3    4    5    6    7    8    9   10   11   12   13   14   15   16   17   18   20*/</span>
<a name="l00257"></a>00257   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00258"></a>00258     <span class="stringliteral">&quot;  %3d %4d %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e %14e\n&quot;</span>,
<a name="l00259"></a>00259     <span class="comment">/* &quot;eq&quot;,           &quot;&quot;,        */</span> gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>,
<a name="l00260"></a>00260     <span class="comment">/* &quot;inp&quot;,          &quot;&quot;,        */</span> gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a> &gt;= 0 ? gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a> : 0,
<a name="l00261"></a>00261     <span class="comment">/* &quot; 3:time&quot;,      &quot;(ns)&quot;,    */</span> gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9,
<a name="l00262"></a>00262     <span class="comment">/* &quot; 4:Hext&quot;,      &quot;(kA/m)&quot;,  */</span> hext*gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>/(<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>*1000.0),
<a name="l00263"></a>00263     <span class="comment">/* &quot; 5:Etot&quot;,      &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00264"></a>00264     <span class="comment">/* &quot; 6:J//Hext&quot;,   &quot;[J/Javg]&quot;,*/</span> valMpHext,
<a name="l00265"></a>00265     <span class="comment">/* &quot; 7:Mx&quot;,        &quot;(1)&quot;,     */</span> Mtot[0],
<a name="l00266"></a>00266     <span class="comment">/* &quot; 8:My&quot;,        &quot;(1)&quot;,     */</span> Mtot[1],
<a name="l00267"></a>00267     <span class="comment">/* &quot; 9:Mz&quot;,        &quot;(1)&quot;,     */</span> Mtot[2],
<a name="l00268"></a>00268     <span class="comment">/* &quot;10:|M|&quot;,       &quot;(1)&quot;,     */</span> sqrt(Mtot[0]*Mtot[0]+Mtot[1]*Mtot[1]+Mtot[2]*Mtot[2]),
<a name="l00269"></a>00269     <span class="comment">/* &quot;11:Edem&quot;,      &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00270"></a>00270 #ifdef EXCH
<a name="l00271"></a>00271     <span class="comment">/* &quot;12:Eanionly&quot;,  &quot;(J/m^3)&quot;, */</span> (gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a>-gdata-&gt;Eexchonly)*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00272"></a>00272 #<span class="keywordflow">else</span>
<a name="l00273"></a>00273     <span class="comment">/* &quot;12:Eexchani&quot;,  &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00274"></a>00274 #endif
<a name="l00275"></a>00275     <span class="comment">/* &quot;13:Eext&quot;,      &quot;(J/m^3)&quot;, */</span> gdata-&gt;<a class="code" href="structGridData.html#a17b4a3f0a4fcf4832fe0004f242a4ecb">Eext</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00276"></a>00276 #ifdef EXCH
<a name="l00277"></a>00277     <span class="comment">/* &quot;14:Eexchonly&quot;, &quot;(J/m^3)&quot;, */</span> gdata-&gt;Eexchonly*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00278"></a>00278 #<span class="keywordflow">else</span>
<a name="l00279"></a>00279     <span class="comment">/* &quot;14:void&quot;,      &quot;&quot;,        */</span> -1.0,
<a name="l00280"></a>00280 #endif
<a name="l00281"></a>00281     <span class="comment">/* &quot;15:devNorm&quot;,   &quot;(1)&quot;,     */</span> devNorm,
<a name="l00282"></a>00282     <span class="comment">/* &quot;16:vequil&quot;,    &quot;(1)&quot;,     */</span> gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>,
<a name="l00283"></a>00283     <span class="comment">/* &quot;17:timestep&quot;,  &quot;(ns)&quot;,    */</span> (gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>-timelast)*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9,
<a name="l00284"></a>00284     <span class="comment">/* &quot;18:tCPU&quot;,      &quot;(s)&quot;,     */</span> t_t1-tCPUstart,
<a name="l00285"></a>00285     <span class="comment">/* &quot;20:CPUtstep&quot;,  &quot;(s)&quot;,     */</span> t_t1-tCPUlast <span class="comment">/* CPU time for last time step */</span>
<a name="l00286"></a>00286   );
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   tCPUlast=t_t1;
<a name="l00289"></a>00289   timelast=gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00292"></a>00292 }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a><a class="code" href="writelog_8c.html#ad970cf1663bac1ede525a5caf43750fd">00295</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00296"></a>00296 {
<a name="l00297"></a>00297   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   ierr = <a class="code" href="writelog_8c.html#a54c21359e5dbade333f4c1ac856a3ffb">WriteLogData</a>(gdata);CHKERRQ(ierr);
<a name="l00300"></a>00300   ierr = <a class="code" href="magpario_8h.html#aa63307197e81d27990850ea179eb5187">WriteLogPid</a>(gdata);CHKERRQ(ierr);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 <span class="preprocessor">#ifdef SUNDIALS_VERSION</span>
<a name="l00303"></a>00303 <span class="preprocessor"></span>  <span class="comment">/* write sundials logfile */</span>
<a name="l00304"></a>00304   ierr = <a class="code" href="writelog__pvode_8c.html#afc3aa13e4e04c3b501cf220d4cc1e3ee">WriteLogPVode</a>(gdata);CHKERRQ(ierr);
<a name="l00305"></a>00305 <span class="preprocessor">#endif</span>
<a name="l00306"></a>00306 <span class="preprocessor"></span>
<a name="l00307"></a>00307 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00308"></a>00308 <span class="preprocessor"></span>  <span class="comment">/* write addons logfile */</span>
<a name="l00309"></a>00309   ierr = WriteLogExt(gdata);CHKERRQ(ierr);
<a name="l00310"></a>00310 <span class="preprocessor">#endif</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>
<a name="l00312"></a>00312 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>  <span class="comment">/* write addons logfile */</span>
<a name="l00314"></a>00314   ierr = WriteLogGMR(gdata);CHKERRQ(ierr);
<a name="l00315"></a>00315 <span class="preprocessor">#endif</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>
<a name="l00317"></a>00317   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00318"></a>00318 }
<a name="l00319"></a>00319 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

